<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<html lang="en">
<head>
<meta content="text/html; charset=utf-8" http-equiv="Content-Type">
<title>
GitLab
</title>

</head>
<body>
<style type="text/css">
img {
max-width: 100%; height: auto;
}
</style>
<div class="content">
<h3>
Philip Carns pushed to branch dev-stdio
at <a href="https://xgitlab.cels.anl.gov/darshan/darshan">darshan / darshan</a>
</h3>
<h4>
Commits:
</h4>
<ul>
<li>
<strong><a href="https://xgitlab.cels.anl.gov/darshan/darshan/commit/7e1b6e9135f92b73d5fdd0cc8bdad42162f18b32">7e1b6e91</a></strong>
<div>
<span>by Phil Carns</span>
<i>at 2016-05-01T09:51:05-04:00</i>
</div>
<pre class="commit-message" style="white-space: pre-wrap">move fwrite wrapper to stdio module</pre>
</li>
</ul>
<h4>8 changed files:</h4>
<ul>
<li class="file-stats">
<a href="#620f2ecad2bb6f74b2fcd0134963a841" style="text-decoration: none">
darshan-runtime/lib/darshan-posix.c
</a>
</li>
<li class="file-stats">
<a href="#ad29afc395839758d41094872298bd0d" style="text-decoration: none">
darshan-runtime/lib/darshan-stdio.c
</a>
</li>
<li class="file-stats">
<a href="#c0b0bf6d71bc5fc7e6d50d69c8aa2413" style="text-decoration: none">
darshan-runtime/share/ld-opts/darshan-posix-ld-opts
</a>
</li>
<li class="file-stats">
<a href="#2ace16276b68c7d5aef163bb260bd9f7" style="text-decoration: none">
darshan-runtime/share/ld-opts/darshan-stdio-ld-opts
</a>
</li>
<li class="file-stats">
<a href="#4dfe7e78b540daa005ea4b5f0458c90d" style="text-decoration: none">
darshan-stdio-log-format.h
</a>
</li>
<li class="file-stats">
<a href="#172f4bf093caeeba24730a1adff8f15a" style="text-decoration: none">
darshan-test/regression/test-cases/src/stdio-test.c
</a>
</li>
<li class="file-stats">
<a href="#a453f91a0a4af7575917fad54f4ac1d0" style="text-decoration: none">
darshan-test/regression/test-cases/stdio-test.sh
</a>
</li>
<li class="file-stats">
<a href="#dffc348e63ffc0037c23afd36439222f" style="text-decoration: none">
darshan-util/darshan-stdio-logutils.c
</a>
</li>
</ul>
<h4>Changes:</h4>
<li id="620f2ecad2bb6f74b2fcd0134963a841">
<a href="https://xgitlab.cels.anl.gov/darshan/darshan/commit/7e1b6e9135f92b73d5fdd0cc8bdad42162f18b32#diff-0">
<strong>
darshan-runtime/lib/darshan-posix.c
</strong>
</a>
<hr>
<pre class="highlight"><code><span style="background: #ffdddd; color: #000000">--- a/darshan-runtime/lib/darshan-posix.c
</span><span style="background: #ddffdd; color: #000000">+++ b/darshan-runtime/lib/darshan-posix.c
</span><span style="color: #aaaaaa">@@ -56,7 +56,6 @@ DARSHAN_FORWARD_DECL(pwrite64, ssize_t, (int fd, const void *buf, size_t count, 
</span> DARSHAN_FORWARD_DECL(readv, ssize_t, (int fd, const struct iovec *iov, int iovcnt));
 DARSHAN_FORWARD_DECL(writev, ssize_t, (int fd, const struct iovec *iov, int iovcnt));
 DARSHAN_FORWARD_DECL(fread, size_t, (void *ptr, size_t size, size_t nmemb, FILE *stream));
<span style="background: #ffdddd; color: #000000">-DARSHAN_FORWARD_DECL(fwrite, size_t, (const void *ptr, size_t size, size_t nmemb, FILE *stream));
</span> DARSHAN_FORWARD_DECL(lseek, off_t, (int fd, off_t offset, int whence));
 DARSHAN_FORWARD_DECL(lseek64, off64_t, (int fd, off64_t offset, int whence));
 DARSHAN_FORWARD_DECL(fseek, int, (FILE *stream, long offset, int whence));
<span style="color: #aaaaaa">@@ -756,37 +755,6 @@ size_t DARSHAN_DECL(fread)(void *ptr, size_t size, size_t nmemb, FILE *stream)
</span>     return(ret);
 }
 
<span style="background: #ffdddd; color: #000000">-size_t DARSHAN_DECL(fwrite)(const void *ptr, size_t size, size_t nmemb, FILE *stream)
-{
-    size_t ret;
-    int aligned_flag = 0;
-    double tm1, tm2;
-
-    MAP_OR_FAIL(fwrite);
-
-    if((unsigned long)ptr % darshan_mem_alignment == 0) aligned_flag = 1;
-
-    tm1 = darshan_core_wtime();
-    ret = __real_fwrite(ptr, size, nmemb, stream);
-    tm2 = darshan_core_wtime();
-
-    POSIX_LOCK();
-    posix_runtime_initialize();
-    if(ret > 0)
-    {
-        POSIX_RECORD_WRITE(size*ret, fileno(stream), 0, 0,
-            aligned_flag, 1, tm1, tm2);
-    }
-    else
-    {
-        POSIX_RECORD_WRITE(ret, fileno(stream), 0, 0,
-            aligned_flag, 1, tm1, tm2);
-    }
-    POSIX_UNLOCK();
-
-    return(ret);
-}
-
</span> off_t DARSHAN_DECL(lseek)(int fd, off_t offset, int whence)
 {
     off_t ret;
</code></pre>

<br>
</li>
<li id="ad29afc395839758d41094872298bd0d">
<a href="https://xgitlab.cels.anl.gov/darshan/darshan/commit/7e1b6e9135f92b73d5fdd0cc8bdad42162f18b32#diff-1">
<strong>
darshan-runtime/lib/darshan-stdio.c
</strong>
</a>
<hr>
<pre class="highlight"><code><span style="background: #ffdddd; color: #000000">--- a/darshan-runtime/lib/darshan-stdio.c
</span><span style="background: #ddffdd; color: #000000">+++ b/darshan-runtime/lib/darshan-stdio.c
</span><span style="color: #aaaaaa">@@ -34,6 +34,7 @@
</span> DARSHAN_FORWARD_DECL(fopen, FILE*, (const char *path, const char *mode));
 DARSHAN_FORWARD_DECL(fopen64, FILE*, (const char *path, const char *mode));
 DARSHAN_FORWARD_DECL(fclose, int, (FILE *fp));
<span style="background: #ddffdd; color: #000000">+DARSHAN_FORWARD_DECL(fwrite, size_t, (const void *ptr, size_t size, size_t nmemb, FILE *stream));
</span> 
 /* The stdio_file_runtime structure maintains necessary runtime metadata
  * for the STDIO file record (darshan_stdio_record structure, defined in
<span style="color: #aaaaaa">@@ -154,7 +155,7 @@ static void stdio_shutdown(void);
</span>     file->offset = 0; \
     file->last_byte_written = 0; \
     file->last_byte_read = 0; \
<span style="background: #ffdddd; color: #000000">-    file->file_record->counters[STDIO_FOPENS] += 1; \
</span><span style="background: #ddffdd; color: #000000">+    file->file_record->counters[STDIO_OPENS] += 1; \
</span>     if(file->file_record->fcounters[STDIO_F_OPEN_START_TIMESTAMP] == 0 || \
      file->file_record->fcounters[STDIO_F_OPEN_START_TIMESTAMP] > __tm1) \
         file->file_record->fcounters[STDIO_F_OPEN_START_TIMESTAMP] = __tm1; \
<span style="color: #aaaaaa">@@ -163,6 +164,28 @@ static void stdio_shutdown(void);
</span> } while(0)
 
 
<span style="background: #ddffdd; color: #000000">+/* TODO: fix write start timestamp and read start timestamp logic in other
+ * modules
+ */
+
+#define STDIO_RECORD_WRITE(__fp, __bytes,  __tm1, __tm2) do{ \
+    int64_t this_offset; \
+    struct stdio_file_runtime* file; \
+    file = stdio_file_by_stream(__fp); \
+    if(!file) break; \
+    this_offset = file->offset; \
+    file->last_byte_written = this_offset + __bytes - 1; \
+    file->offset = this_offset + __bytes; \
+    if(file->file_record->counters[STDIO_MAX_BYTE_WRITTEN] < (this_offset + __bytes - 1)) \
+        file->file_record->counters[STDIO_MAX_BYTE_WRITTEN] = (this_offset + __bytes - 1); \
+    file->file_record->counters[STDIO_BYTES_WRITTEN] += __bytes; \
+    file->file_record->counters[STDIO_WRITES] += 1; \
+    if(file->file_record->fcounters[STDIO_F_WRITE_START_TIMESTAMP] == 0 || \
+     file->file_record->fcounters[STDIO_F_WRITE_START_TIMESTAMP] > __tm1) \
+        file->file_record->fcounters[STDIO_F_WRITE_START_TIMESTAMP] = __tm1; \
+    file->file_record->fcounters[STDIO_F_WRITE_END_TIMESTAMP] = __tm2; \
+    DARSHAN_TIMER_INC_NO_OVERLAP(file->file_record->fcounters[STDIO_F_WRITE_TIME], __tm1, __tm2, file->last_write_end); \
+} while(0)
</span> 
 FILE* DARSHAN_DECL(fopen)(const char *path, const char *mode)
 {
<span style="color: #aaaaaa">@@ -235,6 +258,26 @@ int DARSHAN_DECL(fclose)(FILE *fp)
</span>     return(ret);
 }
 
<span style="background: #ddffdd; color: #000000">+size_t DARSHAN_DECL(fwrite)(const void *ptr, size_t size, size_t nmemb, FILE *stream)
+{
+    size_t ret;
+    double tm1, tm2;
+
+    MAP_OR_FAIL(fwrite);
+
+    tm1 = darshan_core_wtime();
+    ret = __real_fwrite(ptr, size, nmemb, stream);
+    tm2 = darshan_core_wtime();
+
+    STDIO_LOCK();
+    stdio_runtime_initialize();
+    if(ret > 0)
+        STDIO_RECORD_WRITE(stream, size*ret, tm1, tm2);
+    STDIO_UNLOCK();
+
+    return(ret);
+}
+
</span> /**********************************************************
  * Internal functions for manipulating STDIO module state *
  **********************************************************/
</code></pre>

<br>
</li>
<li id="c0b0bf6d71bc5fc7e6d50d69c8aa2413">
<a href="https://xgitlab.cels.anl.gov/darshan/darshan/commit/7e1b6e9135f92b73d5fdd0cc8bdad42162f18b32#diff-2">
<strong>
darshan-runtime/share/ld-opts/darshan-posix-ld-opts
</strong>
</a>
<hr>
<pre class="highlight"><code><span style="background: #ffdddd; color: #000000">--- a/darshan-runtime/share/ld-opts/darshan-posix-ld-opts
</span><span style="background: #ddffdd; color: #000000">+++ b/darshan-runtime/share/ld-opts/darshan-posix-ld-opts
</span><span style="color: #aaaaaa">@@ -15,7 +15,6 @@
</span> --wrap=readv
 --wrap=writev
 --wrap=fread
<span style="background: #ffdddd; color: #000000">---wrap=fwrite
</span> --wrap=lseek
 --wrap=lseek64
 --wrap=fseek
</code></pre>

<br>
</li>
<li id="2ace16276b68c7d5aef163bb260bd9f7">
<a href="https://xgitlab.cels.anl.gov/darshan/darshan/commit/7e1b6e9135f92b73d5fdd0cc8bdad42162f18b32#diff-3">
<strong>
darshan-runtime/share/ld-opts/darshan-stdio-ld-opts
</strong>
</a>
<hr>
<pre class="highlight"><code><span style="background: #ffdddd; color: #000000">--- a/darshan-runtime/share/ld-opts/darshan-stdio-ld-opts
</span><span style="background: #ddffdd; color: #000000">+++ b/darshan-runtime/share/ld-opts/darshan-stdio-ld-opts
</span><span style="color: #aaaaaa">@@ -2,3 +2,4 @@
</span> --wrap=fopen
 --wrap=fopen64
 --wrap=fclose
<span style="background: #ddffdd; color: #000000">+--wrap=fwrite
</span></code></pre>

<br>
</li>
<li id="4dfe7e78b540daa005ea4b5f0458c90d">
<a href="https://xgitlab.cels.anl.gov/darshan/darshan/commit/7e1b6e9135f92b73d5fdd0cc8bdad42162f18b32#diff-4">
<strong>
darshan-stdio-log-format.h
</strong>
</a>
<hr>
<pre class="highlight"><code><span style="background: #ffdddd; color: #000000">--- a/darshan-stdio-log-format.h
</span><span style="background: #ddffdd; color: #000000">+++ b/darshan-stdio-log-format.h
</span><span style="color: #aaaaaa">@@ -40,7 +40,7 @@
</span>  * int      fprintf(FILE *, const char *, ...);
  * int      fputc(int, FILE *);
  * int      fputs(const char *, FILE *);
<span style="background: #ffdddd; color: #000000">- * size_t   fwrite(const void *, size_t, size_t, FILE *);
</span><span style="background: #ddffdd; color: #000000">+ * size_t   fwrite(const void *, size_t, size_t, FILE *);   DONE
</span>  * int      putc(int, FILE *);
  * int      putc_unlocked(int, FILE *);
  * int      putw(int, FILE *);
<span style="color: #aaaaaa">@@ -57,7 +57,13 @@
</span> 
 #define STDIO_COUNTERS \
     /* count of fopens */\
<span style="background: #ffdddd; color: #000000">-    X(STDIO_FOPENS) \
</span><span style="background: #ddffdd; color: #000000">+    X(STDIO_OPENS) \
+    /* maximum byte (offset) written */\
+    X(STDIO_MAX_BYTE_WRITTEN) \
+    /* total bytes written */ \
+    X(STDIO_BYTES_WRITTEN) \
+    /* number of writes */ \
+    X(STDIO_WRITES) \
</span>     /* end of counters */\
     X(STDIO_NUM_INDICES)
 
<span style="color: #aaaaaa">@@ -70,19 +76,25 @@
</span>     X(STDIO_F_CLOSE_START_TIMESTAMP) \
     /* timestamp of last close completion */\
     X(STDIO_F_CLOSE_END_TIMESTAMP) \
<span style="background: #ddffdd; color: #000000">+    /* timestamp of first write */\
+    X(STDIO_F_WRITE_START_TIMESTAMP) \
+    /* timestamp of last write completion */\
+    X(STDIO_F_WRITE_END_TIMESTAMP) \
</span>     /* cumulative meta time */\
     X(STDIO_F_META_TIME) \
<span style="background: #ddffdd; color: #000000">+    /* cumulative write time */\
+    X(STDIO_F_WRITE_TIME) \
</span>     /* end of counters */\
     X(STDIO_F_NUM_INDICES)
 
 #define X(a) a,
<span style="background: #ffdddd; color: #000000">-/* integer counters for the "STDIO" example module */
</span><span style="background: #ddffdd; color: #000000">+/* integer counters for the "STDIO" module */
</span> enum darshan_stdio_indices
 {
     STDIO_COUNTERS
 };
 
<span style="background: #ffdddd; color: #000000">-/* floating point counters for the "STDIO" example module */
</span><span style="background: #ddffdd; color: #000000">+/* floating point counters for the "STDIO" module */
</span> enum darshan_stdio_f_indices
 {
     STDIO_F_COUNTERS
</code></pre>

<br>
</li>
<li id="172f4bf093caeeba24730a1adff8f15a">
<a href="https://xgitlab.cels.anl.gov/darshan/darshan/commit/7e1b6e9135f92b73d5fdd0cc8bdad42162f18b32#diff-5">
<strong>
darshan-test/regression/test-cases/src/stdio-test.c
</strong>
</a>
<hr>
<pre class="highlight"><code><span style="background: #ffdddd; color: #000000">--- a/darshan-test/regression/test-cases/src/stdio-test.c
</span><span style="background: #ddffdd; color: #000000">+++ b/darshan-test/regression/test-cases/src/stdio-test.c
</span><span style="color: #aaaaaa">@@ -50,6 +50,9 @@ int main(int argc, char **argv)
</span>       return(-1);
    }
 
<span style="background: #ddffdd; color: #000000">+   if(mynod == 0)
+      fwrite("hello", 1, 6, file);
+
</span>    fclose(file);
 
    MPI_Finalize();
</code></pre>

<br>
</li>
<li id="a453f91a0a4af7575917fad54f4ac1d0">
<a href="https://xgitlab.cels.anl.gov/darshan/darshan/commit/7e1b6e9135f92b73d5fdd0cc8bdad42162f18b32#diff-6">
<strong>
darshan-test/regression/test-cases/stdio-test.sh
</strong>
</a>
<hr>
<pre class="highlight"><code><span style="background: #ffdddd; color: #000000">--- a/darshan-test/regression/test-cases/stdio-test.sh
</span><span style="background: #ddffdd; color: #000000">+++ b/darshan-test/regression/test-cases/stdio-test.sh
</span><span style="color: #aaaaaa">@@ -27,42 +27,53 @@ if [ $? -ne 0 ]; then
</span>     exit 1
 fi
 
<span style="background: #ffdddd; color: #000000">-# TODO: look for "tail" commands in all of these test cases and remove them
</span><span style="background: #ddffdd; color: #000000">+# TODO: look for "head" commands in all of these test cases and remove them
</span> # later.  Right now they are needed to make sure we only check 1 out of 4
 # possible records because reduction is not implemented yet
 
 # check results
 
 # in this case we want to confirm that the STDIO counters were triggered
<span style="background: #ffdddd; color: #000000">-STDIO_OPENS=`grep STDIO_FOPENS $DARSHAN_TMP/${PROG}.darshan.txt |tail -n 1 |cut -f 5`
</span><span style="background: #ddffdd; color: #000000">+STDIO_OPENS=`grep STDIO_OPENS $DARSHAN_TMP/${PROG}.darshan.txt |head -n 1 |cut -f 5`
</span> if [ ! "$STDIO_OPENS" -gt 0 ]; then
<span style="background: #ffdddd; color: #000000">-    echo "Error: STDIO open count of $STDIO_FOPENS is incorrect" 1>&2
</span><span style="background: #ddffdd; color: #000000">+    echo "Error: STDIO open count of $STDIO_OPENS is incorrect" 1>&2
</span>     exit 1
 fi
<span style="background: #ddffdd; color: #000000">+STDIO_BYTES_WRITTEN=`grep STDIO_BYTES_WRITTEN $DARSHAN_TMP/${PROG}.darshan.txt |head -n 1 |cut -f 5`
+if [ ! "$STDIO_BYTES_WRITTEN" -eq 6 ]; then
+    echo "Error: STDIO open count of $STDIO_BYTES_WRITTEN is incorrect" 1>&2
+    exit 1
+fi
+
</span> 
 # make sure that some of the floating point counters are valid
 # use bc for floating point comparison
<span style="background: #ffdddd; color: #000000">-STDIO_F_OPEN_START_TIMESTAMP=`grep STDIO_F_OPEN_START_TIMESTAMP $DARSHAN_TMP/${PROG}.darshan.txt |tail -n 1 |cut -f 5`
</span><span style="background: #ddffdd; color: #000000">+STDIO_F_OPEN_START_TIMESTAMP=`grep STDIO_F_OPEN_START_TIMESTAMP $DARSHAN_TMP/${PROG}.darshan.txt |head -n 1 |cut -f 5`
</span> if [ ! $(echo "$STDIO_F_OPEN_START_TIMESTAMP > 0" | bc -l) ]; then
     echo "Error: counter is incorrect" 1>&2
     exit 1
 fi
<span style="background: #ffdddd; color: #000000">-STDIO_F_OPEN_END_TIMESTAMP=`grep STDIO_F_OPEN_END_TIMESTAMP $DARSHAN_TMP/${PROG}.darshan.txt |tail -n 1 |cut -f 5`
</span><span style="background: #ddffdd; color: #000000">+STDIO_F_OPEN_END_TIMESTAMP=`grep STDIO_F_OPEN_END_TIMESTAMP $DARSHAN_TMP/${PROG}.darshan.txt |head -n 1 |cut -f 5`
</span> if [ ! $(echo "$STDIO_F_OPEN_END_TIMESTAMP > 0" | bc -l) ]; then
     echo "Error: counter is incorrect" 1>&2
     exit 1
 fi
<span style="background: #ffdddd; color: #000000">-STDIO_F_META_TIME=`grep STDIO_F_META_TIME $DARSHAN_TMP/${PROG}.darshan.txt |tail -n 1 |cut -f 5`
</span><span style="background: #ddffdd; color: #000000">+STDIO_F_META_TIME=`grep STDIO_F_META_TIME $DARSHAN_TMP/${PROG}.darshan.txt |head -n 1 |cut -f 5`
</span> if [ ! $(echo "$STDIO_F_META_TIME > 0" | bc -l) ]; then
     echo "Error: counter is incorrect" 1>&2
     exit 1
 fi
<span style="background: #ffdddd; color: #000000">-STDIO_F_CLOSE_START_TIMESTAMP=`grep STDIO_F_CLOSE_START_TIMESTAMP $DARSHAN_TMP/${PROG}.darshan.txt |tail -n 1 |cut -f 5`
</span><span style="background: #ddffdd; color: #000000">+STDIO_F_WRITE_TIME=`grep STDIO_F_WRITE_TIME $DARSHAN_TMP/${PROG}.darshan.txt |head -n 1 |cut -f 5`
+if [ ! $(echo "$STDIO_F_WRITE_TIME > 0" | bc -l) ]; then
+    echo "Error: counter is incorrect" 1>&2
+    exit 1
+fi
+STDIO_F_CLOSE_START_TIMESTAMP=`grep STDIO_F_CLOSE_START_TIMESTAMP $DARSHAN_TMP/${PROG}.darshan.txt |head -n 1 |cut -f 5`
</span> if [ ! $(echo "$STDIO_F_CLOSE_START_TIMESTAMP > 0" | bc -l) ]; then
     echo "Error: counter is incorrect" 1>&2
     exit 1
 fi
<span style="background: #ffdddd; color: #000000">-STDIO_F_CLOSE_END_TIMESTAMP=`grep STDIO_F_CLOSE_END_TIMESTAMP $DARSHAN_TMP/${PROG}.darshan.txt |tail -n 1 |cut -f 5`
</span><span style="background: #ddffdd; color: #000000">+STDIO_F_CLOSE_END_TIMESTAMP=`grep STDIO_F_CLOSE_END_TIMESTAMP $DARSHAN_TMP/${PROG}.darshan.txt |head -n 1 |cut -f 5`
</span> if [ ! $(echo "$STDIO_F_CLOSE_END_TIMESTAMP > 0" | bc -l) ]; then
     echo "Error: counter is incorrect" 1>&2
     exit 1
</code></pre>

<br>
</li>
<li id="dffc348e63ffc0037c23afd36439222f">
<a href="https://xgitlab.cels.anl.gov/darshan/darshan/commit/7e1b6e9135f92b73d5fdd0cc8bdad42162f18b32#diff-7">
<strong>
darshan-util/darshan-stdio-logutils.c
</strong>
</a>
<hr>
<pre class="highlight"><code><span style="background: #ffdddd; color: #000000">--- a/darshan-util/darshan-stdio-logutils.c
</span><span style="background: #ddffdd; color: #000000">+++ b/darshan-util/darshan-stdio-logutils.c
</span><span style="color: #aaaaaa">@@ -143,12 +143,12 @@ static void darshan_log_print_stdio_record(void *file_rec, char *file_name,
</span> static void darshan_log_print_stdio_description()
 {
     printf("\n# description of STDIO counters:\n");
<span style="background: #ffdddd; color: #000000">-    printf("#   STDIO_FOPENS: number of 'fopen' function calls.\n");
-    printf("#   STDIO_F_OPEN_START_TIMESTAMP: timestamp of the first call to function 'fopen'.\n");
-    printf("#   STDIO_F_OPEN_END_TIMESTAMP: timestamp of the completion of the last call to 'fopen'.\n");
-    printf("#   STDIO_F_CLOSE_START_TIMESTAMP: timestamp of the first call to function 'fclose'.\n");
-    printf("#   STDIO_F_CLOSE_END_TIMESTAMP: timestamp of the completion of the last call to 'fclose'.\n");
-    printf("#   STDIO_F_META_TIME: cumulative time spent in metadata operations.\n");
</span><span style="background: #ddffdd; color: #000000">+    printf("#   STDIO_{OPENS|WRITES} are types of operations.\n");
+    printf("#   STDIO_BYTES_*: total bytes read and written.\n");
+    printf("#   STDIO_MAX_BYTE_*: highest offset byte read and written.\n");
+    printf("#   STDIO_F_*_START_TIMESTAMP: timestamp of the first call to that type of function.\n");
+    printf("#   STDIO_F_*_END_TIMESTAMP: timestamp of the completion of the last call to that type of function.\n");
+    printf("#   STDIO_F_*_TIME: cumulative time spent in different types of functions.\n");
</span> 
     return;
 }
</code></pre>

<br>
</li>

</div>
<div class="footer" style="margin-top: 10px">
<p style="color: #777; font-size: small">

<br>
<a href="https://xgitlab.cels.anl.gov/darshan/darshan/commit/7e1b6e9135f92b73d5fdd0cc8bdad42162f18b32">View it on GitLab</a>.
<br>
You're receiving this email because of your account on xgitlab.cels.anl.gov.
If you'd like to receive fewer emails, you can
adjust your notification settings.

</p>
</div>
</body>
</html>